/*
* TDTP1 :
* Question 1
* Creer une classe Etudiant comportant 2 attributs : nom (String) et moyenne (double)
* Definir un constructeur pour ces deux attributs, et 
*             deux methodes :
*                     a_son_dut(boolean) retournant vrai si la moyenne est >=10, faux sinon
*                     son_nom retournant le nom de l'etudiant
*
* Ecrire une classe principale dans laquelle on creera 2 etudiants, 
*   l'un avec une moyenne superieure a 10 et l'autre une moyenne inferieure a 10
*   Afficher le resultat du DUT pour ces 2 etudiants
*
* Question 2
*  Modifier la classe Etudiant en ajoutant :
*          un constructeur sans parametre
*          une methode lire_etudiant permettant de saisir au clavier un nouvel Etudiant
*          une methode sa_moyenne retournant la moyenne de l'etudiant
*        nb : ne pas oublier les Exceptions
*
* Question 3
*  Modifier la classe principale pour traiter les etudiants dans 
*   un vecteur d'etudiants, disons de 3 etudiants
* 
* Question 4
* Ecrire une sous classe Etudiant_groupe de la classe Etudiant en ajoutant
*    un attribut groupe, les constructeurs et les methodes set_groupe et get_groupe
*    modifier la classe principale en consquence
*
* Question 5
* Ajouter a la classe Etudiant_groupe une methode lire_etudiant qui permet de saisir en plus le groupe
*/

import java.io.*;

// classe Etudiant

class Etudiant {
     // Attributs
     private double moyenne;
     private String nom;

     // Constructeur question 2
     public Etudiant() {
	nom = new String("");
	moyenne = 0;
     }
     // Constructeur
     public Etudiant (String n, double m) {
         nom = new String(n);
         moyenne = m;
     }

     // methode A_son_dut
     boolean a_son_dut() {
          if(moyenne>=10) return true;
          return false;
     }
     
     // methode son_nom
     String son_nom() {
         return nom;
     }

     // methode sa_moyenne  : Question 2
     double sa_moyenne() {
	return moyenne;
     }

     // methode lire_etudiant : Question 2
    void lire_etudiant() throws IOException {
	byte b[] = new byte[128];
	int x;
	String s;
	
	System.out.print("Nom de l'tudiant :");
	x = System.in.read(b,0,128);
	nom = new String(b,0,x-2);

	System.out.print("Moyenne de l'tudiant :");
	x=System.in.read(b,0,128);
	s=new String(b,0,x-2);
	moyenne = (new Double(s)).doubleValue();
    }
}

// Question 4

  class Etudiant_groupe extends Etudiant {
	
	// attribut
	private char groupe;

	// constructeurs
	Etudiant_groupe(String n, double m, char gr) {
		super(n,m);
		groupe = gr;
	}
	Etudiant_groupe() { }

	//  methode set_groupe
	void set_groupe(char g) {
		groupe = g;
	}

	// methode get_groupe
	char get_groupe() {
		return groupe;
	}

	// methode lire_etudiant
	void lire_etudiant() throws IOException  {
		super.lire_etudiant();
		int x;
		byte b[] = new byte[10];
		System.out.print("Groupe de l'etudiant : ");
		x=System.in.read();
		System.out.println("--"+(char)x+"--");
		System.in.read(b,0,10);
		set_groupe((char)x);	
	}
  }

// Classe principale

   class TDTP014 {
     public static void main(String args[]) {

// Question 3
         Etudiant_groupe groupe[];
	int i,n;

	n=3;
	groupe = new Etudiant_groupe[n];
	for(i=0;i<n;i++) {
		groupe[i] = new Etudiant_groupe();
		try {
			groupe[i].lire_etudiant();
		} catch(IOException e) { }
		//groupe[i].set_groupe('A');
 	}   

	System.out.println("Resultats du Dut :");
	for(i=0;i<n;i++) 
	System.out.println(groupe[i].son_nom()+" "+groupe[i].a_son_dut() + " "+groupe[i].sa_moyenne()+" "+groupe[i].get_groupe());
    }
   }